\HEXMAZE.XPL	JUL-11-91
\HEXAGONAL MAZES IN GRAPHICS
\MODIFIED FOR 32-BIT XPL

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	CLEAR=40,	LINE=42,	MOVE=43,	SETVID=45;

def	TV= 0, KB= 0;
def	BEL=$07, TAB= $09, CR= $0D, FF= $0C, ESC=$1B, SP= $20, CTRL=$40;
def	INTSIZE= 4;
def	FULL= false, EMPTY= true,	\SOME USEFUL BOOLEANS
	CLOSED= true, OPEN= false;
def	S3=10, S4=20, S5=24;		\SIZE OF HEXAGONS
def	COLOR=14;
int	ROWS,		\NUMBER OF ROWS
	COLS,		\NUMBER OF COLUMNS
	II, JJ,
	XX, YY;		\CURRENT COORDINATES
int	\ARRAYS
	VWALL,		\VERTICAL WALLS, EITHER OPEN OR CLOSED
	V2WALL,		\VERTICAL WALLS, EITHER OPEN OR CLOSED
	HWALL,		\HORIZONTAL WALLS, EITHER OPEN OR CLOSED
	CELL;		\CELLS OF THE MAZE, EITHER EMPTY OR FULL

\======================================================================

proc	DRAW(CH);
int	CH;
begin
case CH of
  ^/:	[MOVE(XX, YY);   XX:= XX +S3;   LINE(XX, YY-S4, COLOR)];
  ^\:	[MOVE(XX, YY-S4);   XX:= XX +S3;   LINE(XX, YY, COLOR)];
  ^ :	XX:= XX +S3;
  ^_:	[MOVE(XX, YY);   XX:= XX +S5;   LINE(XX, YY, COLOR)]
other;
end;	\DRAW



proc	PRINT;		\PRINT THE MAZE
int	I, J;
begin
CLEAR;
XX:= 0;   YY:= 0;
for J:= 0, ROWS do
	begin
	for I:= 0, COLS-1 do
		begin
		if (I&1) = 0 then		\EVEN COLUMN
			begin
			if J>0 then
			   if V2WALL(I, J-1) = CLOSED then
				DRAW(^\)
			   else	DRAW(^ )
			else DRAW(^ );

			if HWALL(I, J) = CLOSED then
				DRAW(^_)
			else	XX:= XX +S5;
			end
		else	begin			\ODD COLUMN
			if J>0 then
			   if VWALL(I, J-1) = CLOSED then
				DRAW(^/)
			   else	DRAW(^ )
			else DRAW(^ );

			XX:= XX +S5;
			end;
		end;

	\CLOSE OFF
	if J>0 then
	    if (COLS&1) = 0 then		\EVEN COLUMN
		[if V2WALL(COLS, J-1) = CLOSED then DRAW(^\)]
	    else				\ODD COLUMN
		[if VWALL(COLS, J-1) = CLOSED then DRAW(^/)];
	XX:= 0;   YY:= YY +S4;

	for I:= 0, COLS-1 do
		begin
		if (I&1) = 0 then		\EVEN COLUMN
			begin
			if J<ROWS then
			    if VWALL(I, J) = CLOSED then
				[DRAW(^/);   XX:= XX +S5]
			    else XX:= XX +S5 +S3
			else [DRAW(^/);   XX:= XX +S5]; \Prevents wrap around
			end
		else	begin			\ODD COLUMN
			if J>0 then
			   if V2WALL(I, J-1) = CLOSED then
				DRAW(^\)
			   else	DRAW(^ )
			else DRAW(^\);		\PREVENTS WRAP AROUND

			if HWALL(I, J) = CLOSED then
				DRAW(^_)
			else	XX:= XX +S5;
			end;
		end;
	\CLOSE OFF
	if (COLS&1) = 0 then			\EVEN COLUMN
		begin
		if J<ROWS & J>0 then
		    if VWALL(COLS, J) = CLOSED then DRAW(^/);
		end
	else					\ODD COLUMN
		if J>0 then
			[if V2WALL(COLS, J-1) = CLOSED then DRAW(^\)]
		else DRAW(^\);			\PREVENTS WRAP AROUND
	XX:= 0;   YY:= YY +S4;
	end;
end;	\PRINT

\======================================================================

proc	FILL;		\TO FILL THE MAZE WITH PATHS
int	NOFILLED, I, J, SI, SJ;
int	MAXC;		\NUMBER OF CELLS IN THE MAZE



proc	TRACE;		\TO TRACE ONE PATH
int	STUCK, UPOK, DNOK, LFUPOK, RTUPOK, LFDNOK, RTDNOK, DIR;



proc	MOVCHK;		\CHECK POTIENTIAL MOVE
\CAN'T GO OUT OF BOUNDS AND CAN'T MOVE INTO A FILLED CELL.
begin
UPOK:= false;
DNOK:= false;
LFUPOK:= false;
RTUPOK:= false;
LFDNOK:= false;
RTDNOK:= false;

if J > 0 then UPOK:= CELL(I, J-1);		\CAN GO UP?
if J < ROWS-1 then DNOK:= CELL(I, J+1);		\CAN GO DOWN?

if I>0 & J>0 then LFUPOK:= CELL(I-1, if I&1 then J else J-1); \CAN GO LEFT AND UP?
if I>0 & (I&1)=1 & J=0 then LFUPOK:= CELL(I-1, 0); \CAN GO LEFT AND UP?

if I<COLS-1 & J>0 then RTUPOK:= CELL(I+1, if I&1 then J else J-1); \CAN GO RIGHT AND UP?
if I<COLS-1 & (I&1)=1 & J=0 then RTUPOK:= CELL(I+1, 0); \CAN GO RIGHT AND UP?

if I>0 & J<ROWS-1 then LFDNOK:= CELL(I-1, if I&1 then J+1 else J); \CAN GO LEFT AND DOWN?
if I>0 & (I&1)=0 & J=ROWS-1 then LFDNOK:= CELL(I-1, ROWS-1);

if I<COLS-1 & J<ROWS-1 then RTDNOK:= CELL(I+1, if I&1 then J+1 else J); \CAN GO RIGHT AND DOWN?
if I<COLS-1 & (I&1)=0 & J=ROWS-1 then RTDNOK:= CELL(I+1, ROWS-1);

STUCK:= not (UPOK ! DNOK ! LFUPOK ! RTUPOK ! LFDNOK ! RTDNOK);	\ARE WE STUCK?
end;	\MOVCHK



begin	\TRACE
MOVCHK;						\FIND THE VALID DIRECTIONS
while not STUCK do
	begin
	DIR:= RAN(6);				\CHOOSE A RANDOM DIRECTION
	loop	begin				\TRY TO GO THAT WAY
		case DIR of
		  0: if RTUPOK then
			begin
			if (I&1) = 0 \EVEN\ then J:= J -1;
			I:= I +1;
			V2WALL(I, J):= OPEN;
			quit;
			end;
		  1: if LFUPOK then
			begin
			VWALL(I, J):= OPEN;
			if (I&1) = 0 \EVEN\ then J:= J -1;
			I:= I -1;
			quit;
			end;
		  2: if RTDNOK then
			begin
			if (I&1) \ODD\ then J:= J +1;
			I:= I +1;
			VWALL(I, J):= OPEN;
			quit;
			end;
		  3: if LFDNOK then
			begin
			V2WALL(I, J):= OPEN;
			if (I&1) \ODD\ then J:= J +1;
			I:= I -1;
			quit;
			end;
		  4: if UPOK then
			begin
			HWALL(I, J):= OPEN;
			J:= J -1;
			quit;
			end;
		  5: if DNOK then
			begin
			J:= J +1;
			HWALL(I, J):= OPEN;
			quit;
			end
		other;

		DIR:= DIR +1;			\NO GOOD SO TRY NEXT DIRECTION
		if DIR > 5 then DIR:= 0;
		end;

	CELL(I, J):= FULL;			\FOUND ONE, SO MARK IT
	NOFILLED:= NOFILLED +1;			\ONE MORE FULL
	MOVCHK;					\SET UP FOR NEXT MOVE
	end;
end;	\TRACE



proc	NEWCELL;	\STEP TO NEXT CELL (RASTER SCAN)
begin
if SJ+1 < ROWS then SJ:= SJ +1			\GO DOWN IF POSSIBLE
else	begin
	SJ:= 0;					\ELSE GO TO TOP
	if SI+1 < COLS then SI:= SI +1		\AND RIGHT ONE IF POSSIBLE
	else SI:= 0;				\RESET IF WE CANNOT
	end;
I:= SI;
J:= SJ;
end;	\NEWCELL



begin	\FILL
I:= RAN(COLS);					\START AT A RANDOM CELL
J:= RAN(ROWS);
CELL(I, J):= FULL;				\MARK IT FULL
NOFILLED:= 1;					\WE HAVE ONE FULL
SI:= I;						\SAVE STARTING POSITION
SJ:= J;						\ FOR "NEWCELL"

MAXC:= ROWS *COLS;				\FORM ARRAY SIZES

while NOFILLED < MAXC do			\FILL ALL CELLS
	begin
	while CELL(I, J) = EMPTY do		\FIND A FULL CELL
		 NEWCELL;
	TRACE;					\AND TRACE FROM THERE
	NEWCELL;				\THEN GO TO NEXT CELL
	end;
end;	\FILL

\======================================================================

begin	\MAIN
SETVID($12);

\THE MATRICES ARE SEEN AS I BY J, I BEING THE X DIRECTION.
\CELL IS (I, J), WITH I:= 0, COLS-1 AND J:= 0, ROWS-1
\VWALL IS (I, J), WITH I:= 0, COLS AND J:= 0, ROWS-1
\V2WALL IS (I, J), WITH I:= 0, COLS AND J:= 0, ROWS-1
\HWALL IS (I, J), WITH I:= 0, COLS-1 AND J:= 0,ROWS

ROWS:= 11;
COLS:= 17;

CELL:= RESERVE(COLS *INTSIZE);
for II:= 0, COLS-1 do
	CELL(II):= RESERVE(ROWS *INTSIZE);

VWALL:= RESERVE((COLS+1) *INTSIZE);
for II:= 0, COLS do
	VWALL(II):= RESERVE(ROWS *INTSIZE);

V2WALL:= RESERVE((COLS+1) *INTSIZE);
for II:= 0, COLS do
	V2WALL(II):= RESERVE(ROWS *INTSIZE);

HWALL:= RESERVE(COLS *INTSIZE);
for II:= 0, COLS-1 do
	HWALL(II):= RESERVE((ROWS+1) *INTSIZE);

for JJ:= 0, ROWS-1 do 
    for II:= 0, COLS-1 do
	CELL(II, JJ):= EMPTY;			\SET ALL CELLS TO EMPTY

for JJ:= 0, ROWS-1 do 
    for II:= 0, COLS do
	[VWALL(II, JJ):= CLOSED;		\SET ALL WALLS TO CLOSED
	V2WALL(II, JJ):= CLOSED];

for JJ:= 0, ROWS do 
    for II:= 0, COLS-1 do
	HWALL(II, JJ):= CLOSED;

FILL;						\TRACE ALL PATHS
						\OPEN UP THE ENDS
JJ:= RAN(ROWS);					\A RANDOM ROW
VWALL(0, JJ):= OPEN;				\ON THE LEFT
JJ:= RAN(ROWS);					\AND ANOTHER
VWALL(COLS, JJ):= OPEN;				\ON THE RIGHT

PRINT;						\AND PRINT IT
II:= CHIN(1);
SETVID(3);
end;	\MAIN
